namespace :info do
  DEFAULT_STATUS_ENDPOINT = "http://localhost/status"
  Sonoma::Remote.add_optional_config!({
    status_endpoint: "Defaults to #{DEFAULT_STATUS_ENDPOINT}"
  })

  task(:run, [:command]) do |_task, args|
    command = args[:command]
    on roles(:all), in: :sequence do |host|
      execute(*command) # fails unless ok
      info(capture(*command))
    end
  end

  desc "Show docker version"
  task(:docker) do
    command = "sudo docker version"
    Rake::Task["info:run"].invoke(command)
  end

  desc "Show docker processes"
  task(:docker_ps) do
    command = "sudo docker ps"
    Rake::Task["info:run"].invoke(command)
  end

  desc "Show roller stats"
  task(:roller) do
    roller_endpoint = "http://localhost:1875/host/rollinfo"
    Rake::Task["info:run"].invoke("curl -s #{roller_endpoint}")
  end

  desc "Show host status"
  task(:status) do
    status_endpoint = fetch(:status_endpoint, DEFAULT_STATUS_ENDPOINT)
    Rake::Task["info:run"].invoke("curl -sv #{status_endpoint}")
  end
end

